from enum import Enum, unique


@unique
class NoteVisibility(Enum):
    PUBLIC = 'public'
    HOME = 'home'
    FOLLOWERS = 'followers'
    SPECIFIED = 'specified'


@unique
class NotificationsType(Enum):
    FOLLOW = 'follow'
    MENTIONS = 'mention'
    REPLY = 'reply'
    RENOTE = 'renote'
    QUOTE = 'quote'
    REACTION = 'reaction'
    POLL_VOTE = 'pollVote'
    RECEIVE_FOLLOW_REQUEST = 'receiveFollowRequest'
    FOLLOW_REQUEST_ACCEPTED = 'followRequestAccepted'
    GROUP_INVITED = 'groupInvited'
    APP = 'app'


@unique
class LangType(Enum):
    ACH = 'ach'
    ADY = 'ady'
    AF = 'af'
    AF_NA = 'af-NA'
    AF_ZA = 'af-ZA'
    AK = 'ak'
    AR = 'ar'
    AR_AR = 'ar-AR'
    AR_MA = 'ar-MA'
    AR_SA = 'ar-SA'
    AY_BO = 'ay-BO'
    AZ = 'az'
    AZ_AZ = 'az-AZ'
    BE_BY = 'be-BY'
    BG = 'bg'
    BG_BG = 'bg-BG'
    BN = 'bn'
    BN_IN = 'bn-IN'
    BN_BD = 'bn-BD'
    BS_BA = 'bs-BA'
    CA = 'ca'
    CA_ES = 'ca-ES'
    CAK = 'cak'
    CK_US = 'ck-US'
    CS = 'cs'
    CS_CZ = 'cs-CZ'
    CY = 'cy'
    CY_GB = 'cy-GB'
    DA = 'da'
    DA_DK = 'da-DK'
    DE = 'de'
    DE_AT = 'de-AT'
    DE_DE = 'de-DE'
    DE_CH = 'de-CH'
    DSB = 'dsb'
    EL = 'el'
    EL_GR = 'el-GR'
    EN = 'en'
    EN_GB = 'en-GB'
    EN_AU = 'en-AU'
    EN_CA = 'en-CA'
    EN_IE = 'en-IE'
    EN_IN = 'en-IN'
    EN_PI = 'en-PI'
    EN_UD = 'en-UD'
    EN_US = 'en-US'
    EN_ZA = 'en-ZA'
    EN_PIRATE = 'en@pirate'
    EO = 'eo'
    EO_EO = 'eo-EO'
    ES = 'es'
    ES_AR = 'es-AR'
    ES_419 = 'es-419'
    ES_CL = 'es-CL'
    ES_CO = 'es-CO'
    ES_EC = 'es-EC'
    ES_ES = 'es-ES'
    ES_LA = 'es-LA'
    ES_NI = 'es-NI'
    ES_MX = 'es-MX'
    ES_US = 'es-US'
    ES_VE = 'es-VE'
    ET = 'et'
    ET_EE = 'et-EE'
    EU = 'eu'
    EU_ES = 'eu-ES'
    FA = 'fa'
    FA_IR = 'fa-IR'
    FB_LT = 'fb-LT'
    FF = 'ff'
    FI = 'fi'
    FI_FI = 'fi-FI'
    FO_FO = 'fo-FO'
    FR = 'fr'
    FR_CA = 'fr-CA'
    FR_FR = 'fr-FR'
    FR_BE = 'fr-BE'
    FR_CH = 'fr-CH'
    FY_NL = 'fy-NL'
    GA = 'ga'
    GA_IE = 'ga-IE'
    GL = 'gl'
    GL_ES = 'gl-ES'
    GN_PY = 'gn-PY'
    GU_IN = 'gu-IN'
    GX_GR = 'gx-GR'
    HE = 'he'
    HE_IL = 'he-IL'
    HI = 'hi'
    HI_IN = 'hi-IN'
    HR = 'hr'
    HR_HR = 'hr-HR'
    HSB = 'hsb'
    HT = 'ht'
    HU = 'hu'
    HU_HU = 'hu-HU'
    HY_AM = 'hy-AM'
    ID = 'id'
    ID_ID = 'id-ID'
    IS = 'is'
    IS_IS = 'is-IS'
    IT = 'it'
    IT_IT = 'it-IT'
    JA = 'ja'
    JA_JP = 'ja-JP'
    JV_ID = 'jv-ID'
    KA_GE = 'ka-GE'
    KK_KZ = 'kk-KZ'
    KM = 'km'
    KM_KH = 'km-KH'
    KAB = 'kab'
    KN = 'kn'
    KN_IN = 'kn-IN'
    KO = 'ko'
    KO_KR = 'ko-KR'
    KU_TR = 'ku-TR'
    LA = 'la'
    LA_VA = 'la-VA'
    LB = 'lb'
    LI_NL = 'li-NL'
    LT = 'lt'
    LT_LT = 'lt-LT'
    LV = 'lv'
    LV_LV = 'lv-LV'
    MAI = 'mai'
    MG_MG = 'mg-MG'
    MK = 'mk'
    MK_MK = 'mk-MK'
    ML = 'ml'
    ML_IN = 'ml-IN'
    MN_MN = 'mn-MN'
    MR = 'mr'
    MR_IN = 'mr-IN'
    MS = 'ms'
    MS_MY = 'ms-MY'
    MT = 'mt'
    MT_MT = 'mt-MT'
    MY = 'my'
    NO = 'no'
    NB = 'nb'
    NB_NO = 'nb-NO'
    NE = 'ne'
    NE_NP = 'ne-NP'
    NL = 'nl'
    NL_BE = 'nl-BE'
    NL_NL = 'nl-NL'
    NN_NO = 'nn-NO'
    OC = 'oc'
    OR_IN = 'or-IN'
    PA = 'pa'
    PA_IN = 'pa-IN'
    PL = 'pl'
    PL_PL = 'pl-PL'
    PS_AF = 'ps-AF'
    PT = 'pt'
    PT_BR = 'pt-BR'
    PT_PT = 'pt-PT'
    QU_PE = 'qu-PE'
    RM_CH = 'rm-CH'
    RO = 'ro'
    RO_RO = 'ro-RO'
    RU = 'ru'
    RU_RU = 'ru-RU'
    SA_IN = 'sa-IN'
    SE_NO = 'se-NO'
    SI_LK = 'si-LK'
    SK = 'sk'
    SK_SK = 'sk-SK'
    SL = 'sl'
    SL_SI = 'sl-SI'
    SO_SO = 'so-SO'
    SQ = 'sq'
    SQ_AL = 'sq-AL'
    SR = 'sr'
    SR_RS = 'sr-RS'
    SU = 'su'
    SV = 'sv'
    SV_SE = 'sv-SE'
    SW = 'sw'
    SW_KE = 'sw-KE'
    TA = 'ta'
    TA_IN = 'ta-IN'
    TE = 'te'
    TE_IN = 'te-IN'
    TG = 'tg'
    TG_TJ = 'tg-TJ'
    TH = 'th'
    TH_TH = 'th-TH'
    TL = 'tl'
    TL_PH = 'tl-PH'
    TLH = 'tlh'
    TR = 'tr'
    TR_TR = 'tr-TR'
    TT_RU = 'tt-RU'
    UK = 'uk'
    UK_UA = 'uk-UA'
    UR = 'ur'
    UR_PK = 'ur-PK'
    UZ = 'uz'
    UZ_UZ = 'uz-UZ'
    VI = 'vi'
    VI_VN = 'vi-VN'
    XH_ZA = 'xh-ZA'
    YI = 'yi'
    YI_DE = 'yi-DE'
    ZH = 'zh'
    ZH_HANS = 'zh-Hans'
    ZH_HANT = 'zh-Hant'
    ZH_CN = 'zh-CN'
    ZH_HK = 'zh-HK'
    ZH_SG = 'zh-SG'
    ZH_TW = 'zh-TW'
    ZU_ZA = 'zu-ZA'


@unique
class Permissions(Enum):
    READ_ACCOUNT = 'read:account'
    WRITE_ACCOUNT = 'write:account'
    READ_BLOCKS = 'read:blocks'
    WRITE_BLOCKS = 'write:blocks'
    READ_DRIVE = 'read:drive'
    WRITE_DRIVE = 'write:drive'
    READ_FAVORITES = 'read:favorites'
    READ_FOLLOWING = 'read:following'
    WRITE_FOLLOWING = 'write:following'
    READ_MESSAGING = 'read:messaging'
    WRITE_MESSAGING = 'write:messaging'
    READ_MUTES = 'read:mutes'
    WRITE_MUTES = 'write:mutes'
    WRITE_NOTES = 'write:notes'
    READ_NOTIFICATIONS = 'read:notifications'
    WRITE_NOTIFICATIONS = 'write:notifications'
    READ_REACTIONS = 'read:reactions'
    WRITE_REACTIONS = 'write:reactions'
    WRITE_VOTES = 'write:votes'
    READ_PAGES = 'read:pages'
    WRITE_PAGES = 'write:pages'
    WRITE_PAGE_LIKES = 'write:page-likes'
    READ_PAGE_LIKES = 'read:page-likes'
    READ_USER_GROUPS = 'read:user-groups'
    WRITE_USER_GROUPS = 'write:user-groups'
    READ_CHANNELS = 'read:channels'
    WRITE_CHANNELS = 'write:channels'
    READ_GALLERY = 'read:gallery'
    WRITE_GALLERY = 'write:gallery'
    READ_GALLERY_LIKES = 'read:gallery-likes'
    WRITE_GALLERY_LIKES = 'write:gallery-likes'
